<script context="module">
  // We need to configure highlight.js for Javascript, and then alias the
  // exports to match the function signatures that `CodeJar` Component expects
  import hljs from "highlight.js/lib/core";
  import json from "highlight.js/lib/languages/json";

  hljs.registerLanguage("json", json);

  // `highlight` takes the input code and returns the highlighted HTML markup
  const highlight = (code, syntax) =>
    hljs.highlight(code, {
      language: syntax,
    }).value;
</script>

<script lang="ts">
  import { CodeJar } from "@novacbn/svelte-codejar";
  import type { Repository } from "$lib/types/githubResults.type";
  export let repository: Repository;
  export let showOrkgForm: boolean;
  export let jsonRepository = JSON.stringify(repository, null, 2);

  let jsonUrl: string =
    "data:text/json;charset=utf-8," + encodeURIComponent(jsonRepository);
  let jsonFileName: string = `BettysResult_${repository.name}.json`;
  $: {
    jsonUrl =
      "data:text/json;charset=utf-8," + encodeURIComponent(jsonRepository);
  }
</script>

<div class="border-solid border-2 p-2">
  <div class="border-solid border-2 p-1 rounded-md text-center">
    <p
      class="mb-4 text-3xl font-normal leading-none tracking-tight text-gray-500 md:text-3xl lg:text-3xl"
    >
      This is what we were able to extract
    </p>
    <p
      class="mb-6 text-base font-normal text-gray-500 lg:text-xl sm:px-16 xl:px-48 dark:text-gray-400"
    >
      You can edit any value from the json*
    </p>
  </div>
  <CodeJar
    class="hljs"
    syntax="json"
    withLineNumbers={true}
    {highlight}
    bind:value={jsonRepository}
  />

  <div class="lg:flex items-center content-center justify-center space-x-8">
    <a
      href={jsonUrl}
      download={jsonFileName}
      class="mt-6 ml-16 mr-16 mb-8 w-40 btn px-6 py-2.5 bg-cyan-600 text-white no-underline font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-cyan-700 hover:shadow-lg focus:bg-cyan-700 focus:shadow-lg focus:outline-none focus:ring-0 active:bg-cyan-800 active:shadow-lg transition duration-150 ease-in-out flex justify-center"
      >download</a
    >

    <button
      class="mt-6 ml-16 mr-16 mb-8 w-40 btn px-6 py-2.5 bg-cyan-600 text-white no-underline font-medium text-xs leading-tight uppercase rounded shadow-md hover:bg-cyan-700 hover:shadow-lg focus:bg-cyan-700 focus:shadow-lg focus:outline-none focus:ring-0 active:bg-cyan-800 active:shadow-lg transition duration-150 ease-in-out flex justify-center"
      on:click={() => {
        showOrkgForm = true;
      }}>Next</button
    >
  </div>
</div>

<style>
  @import "highlight.js/styles/idea.css";
</style>
